
function Draw()
	triangles = 0
	if shader then
		gfx.setShader(effect)
	else
		gfx.setShader()
	end
	for i = 1, #objects do
		local face = {}
		local vertecies = {}
		local poly = {}
		local polyZ = {}
		local verteciesZ = {}

		for Type, object in pairs(objects[i]) do
			if Type == "vertecies" then
				for key, vertex in pairs(object) do
					local x = vertex.x / -vertex.z
					local y = vertex.y / -vertex.z

					if tonumber(vertex.z) > 0 then
						x = x * -10
						y = y * -10
					end

					x = 400 + x*600
					y = 400 + y*600
					vertecies[#vertecies + 1] = {x, y}
					verteciesZ[#verteciesZ + 1] = tonumber(vertex.z)
				end
			end
			if Type == "faces" then
				for key, faces in pairs(object) do
					face[key] = faces
				end
			end
		end

		for t = 1, #face do
			if #face[t] == 3 then
				local temp = {}
				local temp2 = {}
				local a, b, c = tonumber(face[t][1]), tonumber(face[t][2]), tonumber(face[t][3])
				temp[1] = vertecies[a]
				temp[2] = vertecies[b]
				temp[3] = vertecies[c]
				poly[t] = {temp[1][1], temp[1][2], temp[2][1], temp[2][2], temp[3][1], temp[3][2]}
				temp2[1] = verteciesZ[a]
				temp2[2] = verteciesZ[b]
				temp2[3] = verteciesZ[c]
				polyZ[t] = {temp2[1], temp2[2], temp2[3]}
			else
				error("WTF?", 1)
			end
		end

		gfx.setColor(255, 255, 255, 255)
		for r = 1, #poly do
			if polyZ[r][1] < 0 or polyZ[r][2] < 0 or polyZ[r][3] < 0 then
				if culling then
					if ( (poly[r][1]*poly[r][4] - poly[r][2]*poly[r][3]) + (poly[r][3]*poly[r][6] - poly[r][4]*poly[r][5]) + (poly[r][5]*poly[r][2] - poly[r][6]*poly[r][1]) )/2 > 0 then
						gfx.polygon("fill", poly[r])
					end
				else
					gfx.polygon("fill", poly[r])
				end
			end
		end
		triangles = triangles + #poly
	end
end


function addModelKeys(key)
	if key == "f12" then
		model.addModel("sphere", 1)
	end
	if key == "f11" then
		model.addModel("cube", 1)
	end
end